#include "TwoClassNLLCriterion.h"
#include "log_add.h"

namespace Torch {

TwoClassNLLCriterion::TwoClassNLLCriterion(real cst_) : Criterion(1)
{
  cst = cst_;
}

void TwoClassNLLCriterion::frameForward(int t, real *f_inputs, real *f_outputs)
{
  real y = data->targets->frames[0][0];
  f_outputs[0] = logAdd(0, cst-y*f_inputs[0]);
}

void TwoClassNLLCriterion::frameBackward(int t, real *f_inputs, real *beta_, real *f_outputs, real *alpha_)
{
  if(partial_backprop)
    return;

  real y = data->targets->frames[0][0];
  beta_[0] = - y * (1.-exp(-f_outputs[0]));
}

TwoClassNLLCriterion::~TwoClassNLLCriterion()
{
}

}
