#ifndef IPNORM_MEAN_STDV_LIGHT_INC
#define IPNORM_MEAN_STDV_LIGHT_INC

#include "ipCore.h"

namespace Torch {

/** This class is designed to normalize an image by substracting the average light

    @author Sebastien Marcel (marcel@idiap.ch)
    @version 2.0
    \Date
    @since 2.0
*/
class ipNormMeanStdvLight : public ipCore
{
   	// width of the input image
	int width;

	// height of the input image
	int height;

	//
	real c;
public:
	/** constructor
	    
	    @param width_ is the #width# of the input image
	    @param height_ is the #height# of the input image
	    @param coding_ is the #coding# format of the input image
	    @param c_ is the variance factor
	*/
    	ipNormMeanStdvLight(int width_, int height_, const char *coding_, real c_=1.0);

	///
	virtual ~ipNormMeanStdvLight();

	///
	virtual void process(Sequence *seq_in);
};

}

#endif
