#ifndef XT_PROBE_IMAGE_DISK_X_FILE_INC
#define XT_PROBE_IMAGE_DISK_X_FILE_INC

#include "ImageDiskXFile.h"

namespace Torch {

/** This class is designed to load an image from the disk using the extension of filename to probe the format
    
    @author Sebastien Marcel (marcel@idiap.ch)
    @version 2.0
    \Date
    @since 1.0
*/
class xtprobeImageDiskXFile : public ImageDiskXFile
{
  	ImageDiskXFile *ixfile;

public:
   	/**@name constructor and destructor */
        //@{
	/** Makes a ImageDiskXFile from an filename.
	
	    @param file_name is the filename of the image
	    @param open_flags is the opening mode of the file
	*/
	xtprobeImageDiskXFile(const char *file_name, const char *open_flags);

	/// Destructor
    	virtual ~xtprobeImageDiskXFile();
	//@}
	
   	/**@name read/write image header and image pixmap */
        //@{
	/** read the header from the file.
	
	    @param width_ is the width of the image read in the header
	    @param height_ is the height of the image read in the header
	*/
	virtual bool readHeader(int *width_, int *height_);

	/// read the #pixmap# from the file
	virtual int readPixmap();

	/** write the header from the file.
	
	    @param width_ is the width of the image written in the header
	    @param height_ is the height of the image written in the header
	*/
	virtual bool writeHeader(int width_, int height_);

	/// write the #pixmap_# into the file
	virtual int writePixmap(unsigned char *pixmap_);
	//@}
};

}

#endif
