#ifndef IPSUBWINDOW_INC
#define IPSUBWINDOW_INC

#include "ipCore.h"

namespace Torch {
   
/** This class is designed to classify a subwindow of an image

    @author Sebastien Marcel (marcel@idiap.ch)
    @author Yann Rodriguez (yann.rodriguez@idiap.ch)
    @version 2.0
    \Date
    @since 1.0
*/
class ipSubWindow : public ipCore
{
public:
	/// pattern width
	int width_pattern;

	/// pattern height
	int height_pattern;
	
	/// image width
	int width_image;

	/// image height
	int height_image;

	/// window x location
	short int x_window;
	
	/// window y location
	short int y_window;

	/// window width
	short int w_window;

	/// window height
	short int h_window;

	/// window x location in the real image
	short int real_x_window;

	/// window y location in the real image
	short int real_y_window;

	/// threshold
	real threshold;

	///
	bool ispattern;

	/// view to be defined, zero is the default value
	int view;
	
	///
	ipSubWindow(int width_image_, int height_image_, int width_pattern_, int height_pattern_, real threshold_);

	///
	virtual void resetWindowX(int x_window_) { x_window = x_window_; };

	///
	virtual void resetWindowY(int y_window_) { y_window = y_window_; };

	///
	virtual void resetWindowSize(int w_window_, int h_window_) { w_window = w_window_; h_window = h_window_; };
	
	///
	inline bool isPattern() { return ispattern; };
	
	///
	virtual void stat(void) {};

	///
	virtual ~ipSubWindow();
};

}
#endif
