#include "IOBinDisk.h"

namespace Torch {

IOBinDisk::IOBinDisk(const char *filename_, int max_load_) : IOBin(filename_, false, max_load_, false)
{
  	file = new(allocator) DiskXFile(filename_, "r");
	
	current_pos = 0;
}

void IOBinDisk::getSequence(int t, Sequence *sequence)
{
	//if(current_pos == t-1)
	{
		// seeks to the frame
		if(file->seek(t*frame_size*sizeof(real)+2*sizeof(int), SEEK_SET) != 0)
        		error("IOBinDisk: cannot seek in your file!");
	}

    	// reads the frame
    	file->read(sequence->frames[0], sizeof(real), frame_size);

	current_pos = t;
}

IOBinDisk::~IOBinDisk()
{
}

}
