#include "NormMeanStdvImagePreProcessing.h"

namespace Torch {

NormMeanStdvImagePreProcessing::NormMeanStdvImagePreProcessing(int width_, int height_)
{
   	width = width_;
	height = height_;

	n_inputs = width * height;
	
	ip_machine = new(allocator) ipNormMeanStdvLight(width, height, "float");
}

void NormMeanStdvImagePreProcessing::preProcessInputs(Sequence *inputs)
{
	if(inputs->frame_size != n_inputs)
		error("NormMeanStdvImagePreProcessing: sequence->frame_size != (width * height)");

	ip_machine->process(inputs);
	
	real *output_ = ip_machine->seq_out->frames[0];
	   
	for(int i = 0 ; i < n_inputs ; i++) inputs->frames[0][i] = output_[i];
}

void NormMeanStdvImagePreProcessing::preProcessTargets(Sequence *targets)
{
}

NormMeanStdvImagePreProcessing::~NormMeanStdvImagePreProcessing()
{
}

}

