#ifndef VIRTUAL_PIXMAP_INC
#define VIRTUAL_PIXMAP_INC

namespace Torch {

/** This class is designed to handle a virtual pixmap

    @author Sebastien Marcel (marcel@idiap.ch) 
    @version 2.0
    \Date
    @since 1.0
*/
class VirtualPixmap
{
public:
	/** @name constructors */
	//@{
	///
	VirtualPixmap() {};

	///
	VirtualPixmap (const VirtualPixmap &) {};

	///
	VirtualPixmap & operator = (const VirtualPixmap &) { return *this; };
	//@}
	
	/// destructor
	virtual ~VirtualPixmap() {};

	/// returns the width of the VirtualPixmap
	virtual unsigned int getwidth() const = 0;

	/// returns the height of the VirtualPixmap
	virtual unsigned int getheight() const = 0;

	/// returns the number of bytes per line of the VirtualPixmap
	virtual const int bytes_per_line() const = 0;
	
	/// returns the pixmap of the VirtualPixmap
	virtual const unsigned char *getpixmap() const = 0;

	/// copy the VirtualPixmap from a buffer
	virtual void copyBuffer(unsigned char *) {};
}; 

}

#endif 

